
<template>
<div class="app-login-view app-login-view">
    <img class="login-bg" src="/assets/img/background.png" />
    <div class="login-container">
      <div class="login-title">{{appTitle}}</div>
      <i-form ref='loginForm' class="login-form" :rules="rules" :model="formData">
        <form-item prop="loginname">
          <i-input
            size="large"
            prefix="ios-contact"
            v-model.trim="formData.loginname"
            :placeholder="$t('components.login.placeholder1')"
            @keyup.enter.native="handleSubmit"
          >
          </i-input>
        </form-item>
        <form-item prop="password">
          <i-input
            size="large"
            prefix="ios-key"
            v-model.trim="formData.password"
            type="password"
            :placeholder="$t('components.login.placeholder2')"
            @keyup.enter.native="handleSubmit"
          >
          </i-input>
        </form-item>
        <form-item class="app-login-view__buttons">
          <i-button @click="handleSubmit" type="primary" class="login_btn"
            >{{ $t("components.login.name") }}
          </i-button>
          <i-button @click="goReset" class="login_reset"
            >{{ $t("components.login.reset") }}
          </i-button>
        </form-item>

        <form-item class="app-login-view__icons">
          <div style="text-align: center">
            <span class="form_tipinfo">{{ $t("components.login.other") }}</span>
          </div>
          <div style="text-align: center">
            <div class="icon" @click="tencentHandleClick('tencent')">
              <img src="/assets/img/QQ.svg" draggable="false" />
            </div>
            <div class="icon" @click="wechatHandleClick('wechat')">
              <img src="/assets/img/weixin.svg" draggable="false" />
            </div>
          </div>
        </form-item>
      </i-form>
      <p class="login-tip">
        {{ this.loginTip }}
      </p>
      <div class="app-login-view__footer">
        <div class="copyright">
          <a href="https://www.ibizlab.cn/" target="_blank"
            >{{ appTitle }} is based on ibizlab .</a
          >
        </div>
      </div>
    </div>
</div>

</template>
// 基于 @VIEW/应用登录视图/VIEW-BASE.vue.ftl 生成
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch,Inject } from 'vue-property-decorator';
import { UIActionTool, Util } from '@/utils';
import axios from 'axios';
import { AppMessageBox } from '@/utils/app-message-box/app-message-box';
import NavDataService from '@/service/app/navdata-service';
import { Subject,Subscription } from 'rxjs';



import { Environment } from '@/environments/environment';


@Component({
    components: {
    },
})
export default class AppLoginViewBase extends Vue {
    
    /**
     * 数据变化
     *
     * @param {*} val
     * @returns {*}
     * @memberof AppLoginViewBase
     */
    @Emit() 
    public viewDatasChange(val: any):any {
        return val;
    }

    /**
     * 传入视图上下文
     *
     * @type {string}
     * @memberof AppLoginViewBase
     */
    @Prop() public viewdata!: string;

    /**
     * 传入视图参数
     *
     * @type {string}
     * @memberof AppLoginViewBase
     */
    @Prop() public viewparam!: string;

    /**
     * 视图默认使用
     *
     * @type {boolean}
     * @memberof AppLoginViewBase
     */
    @Prop({ default: true }) public viewDefaultUsage!: boolean;

    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof AppLoginViewBase
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;

    /**
     * 打开方式
     * 
     * @type {'ROUTE' | 'EMBED' | 'MODAL'}
     * @memberof AppLoginViewBase
     */
    @Prop({ default: 'ROUTE' }) public openType!: 'ROUTE' | 'EMBED' | 'MODAL';

	/**
	 * 视图标识
	 *
	 * @type {string}
	 * @memberof AppLoginViewBase
	 */
	public viewtag: string = 'DDD1152C-0A9F-44C5-82FA-7F6A469C5569';

    /**
	 * 视图类型
	 *
	 * @type {string}
	 * @memberof AppLoginViewBase
	 */
	public viewType: string = 'APPLOGINVIEW';

	/**
	 * 自定义视图导航上下文集合
	 *
	 * @type {*}
	 * @memberof AppLoginViewBase
	 */
    public customViewNavContexts:any ={
    };

	/**
	 * 自定义视图导航参数集合
	 *
	 * @type {*}
	 * @memberof AppLoginViewBase
	 */
    public customViewParams:any ={
    };

    /**
     * 视图模型数据
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public model: any = {
        srfCaption: 'app.views.apploginview.caption',
        srfTitle: 'app.views.apploginview.title',
        srfSubTitle: 'app.views.apploginview.subtitle',
        dataInfo: ''
    }

    /**
     * 视图参数变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof AppLoginViewBase
     */
    @Watch('viewparam',{immediate: true, deep: true})
    onParamData(newVal: any, oldVal: any) {
        if(newVal){
            this.viewparams = {};
            if(typeof newVal == 'string') {
                Object.assign(this.viewparams, JSON.parse(this.viewparam));
            }else{
                this.viewparams = Util.deepCopy(this.viewparam);
            }
            
        } 
    }

    /**
     * 处理应用上下文变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof AppLoginViewBase
     */
    @Watch('viewdata')
    onViewData(newVal: any, oldVal: any) {
        const _this: any = this;
        
        if (!Object.is(newVal, oldVal) && _this.engine) {
            this.$nextTick(()=>{
              _this.parseViewParam();
              _this.engine.load();
            });
        } else if(!Object.is(newVal, oldVal) && _this.refresh && _this.refresh instanceof Function) {
            _this.refresh();
        }
    }

    /**
     * 容器模型
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public containerModel: any = {
    };

    /**
     * 视图操作参数
     *
     * @type {*}
     * @readonly
     * @memberof AppLoginViewBase
     */
    public viewCtx: any = {};

    /**
     *  计数器刷新
     *
     * @memberof AppLoginViewBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }

    /**
     * 视图状态订阅对象
     *
     * @public
     * @type {Subject<{action: string, data: any}>}
     * @memberof AppLoginViewBase
     */
    public viewState: Subject<ViewState> = new Subject();



    /**
     * 引擎初始化
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public engineInit(): void {
    }

    /**
     * 应用导航服务
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public  navDataService = NavDataService.getInstance();

    /**
    * 导航服务事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof AppLoginViewBase
    */
    public serviceStateEvent: Subscription | undefined;

    /**
     * 门户部件状态对象
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    @Prop() public portletState?: any;

    /**
     * 门户部件状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof AppLoginViewBase
     */
    public portletStateEvent: Subscription | undefined;

    /**
    * 门户部件状态事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof AppLoginViewBase
    */
    public formDruipartEvent: Subscription | undefined;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public context:any = {};

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public viewparams:any = {};

    /**
     * 视图缓存数据
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public viewCacheData:any;


    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof AppLoginViewBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 解析视图参数
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public parseViewParam(inputvalue:any = null): void {
        for(let key in this.context){
            delete this.context[key];
        }
        if(this.$store.getters.getAppData() && this.$store.getters.getAppData().context){
            Object.assign(this.context,this.$store.getters.getAppData().context);
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            if(typeof this.viewdata == 'string') {
                Object.assign(this.context, JSON.parse(this.viewdata));
            }
            if(this.context && this.context.srfparentdename){
                Object.assign(this.viewparams,{srfparentdename:this.context.srfparentdename});
            }
            if(this.context && this.context.srfparentkey){
                Object.assign(this.viewparams,{srfparentkey:this.context.srfparentkey});
            }
            this.handleCustomViewData();
            return;
        }
        const path = (this.$route.matched[this.$route.matched.length - 1]).path;
        const keys: Array<any> = [];
        const curReg = this.$pathToRegExp.pathToRegexp(path, keys);
        const matchArray = curReg.exec(this.$route.path);
        let tempValue: Object = {};
        keys.forEach((item: any, index: number) => {
            if(matchArray[index + 1]){
                Object.defineProperty(tempValue, item.name, {
                    enumerable: true,
                    value: decodeURIComponent(matchArray[index + 1])
                });
            }
        });
        this.$viewTool.formatRouteParams(tempValue,this.$route,this.context,this.viewparams);
        this.handleCustomViewData();
        //初始化导航数据
        this.initNavDataWithRoute();
    }

    /**
     * 处理自定义视图数据
     *
     * @memberof AppLoginViewBase
     */
	public handleCustomViewData(){
		if(Object.keys(this.customViewNavContexts).length > 0){
			Object.keys(this.customViewNavContexts).forEach((item:any) =>{
				let tempContext:any = {};
				let curNavContext:any = this.customViewNavContexts[item];
				this.handleCustomDataLogic(curNavContext,tempContext,item);
				Object.assign(this.context,tempContext);
			})
		}
		if(Object.keys(this.customViewParams).length > 0){
			Object.keys(this.customViewParams).forEach((item:any) =>{
				let tempParam:any = {};
				let curNavParam:any = this.customViewParams[item];
				this.handleCustomDataLogic(curNavParam,tempParam,item);
				Object.assign(this.viewparams,tempParam);
			})
		}
	}

    /**
     * 处理自定义视图数据逻辑
     *
     * @memberof AppLoginViewBase
     */
	public handleCustomDataLogic(curNavData:any,tempData:any,item:string){
		// 直接值直接赋值
		if(curNavData.isRawValue){
			if(Object.is(curNavData.value,"null") || Object.is(curNavData.value,"")){
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: null,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }else{
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: curNavData.value,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }
		}else{
			// 先从导航上下文取数，没有再从导航参数（URL）取数，如果导航上下文和导航参数都没有则为null
			if(this.context[(curNavData.value).toLowerCase()] != null){
				Object.defineProperty(tempData, item.toLowerCase(), {
					value: this.context[(curNavData.value).toLowerCase()],
					writable : true,
					enumerable : true,
					configurable : true
				});
			}else{
				if(this.viewparams[(curNavData.value).toLowerCase()] != null){
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: this.viewparams[(curNavData.value).toLowerCase()],
						writable : true,
						enumerable : true,
						configurable : true
					});
				}else{
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: null,
						writable : true,
						enumerable : true,
						configurable : true
					});
				}
			}
		}
	}

    /**
     * 初始化导航数据(路由模式)
     *
     * @memberof AppLoginViewBase
     */
    public initNavDataWithRoute(data:any = null, isNew:boolean = false,  isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && Object.is(this.navModel,"route")) ){
            this.navDataService.addNavData({id:'app-login-view',tag:this.viewtag,srfkey:isNew ? null : null,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath});
        }
    }

    /**
     * 初始化导航数据(分页模式)
     *
     * @memberof AppLoginViewBase
     */
    public initNavDataWithTab(data:any = null,isOnlyAdd:boolean = true, isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && !Object.is(this.navModel,"route")) ){
            this.navDataService.addNavDataByOnly({id:'app-login-view',tag:this.viewtag,srfkey:null,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath},isOnlyAdd);
        }
    }
	

    /**
     * Vue声明周期
     *
     * @memberof AppLoginViewBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     * @memberof AppLoginViewBase
     */    
    public afterCreated(){
        let _this:any = this;
        const secondtag = _this.$util.createUUID();
        _this.$store.commit('viewaction/createdView', { viewtag: _this.viewtag, secondtag: secondtag });
        _this.viewtag = secondtag;
        _this.parseViewParam();
        _this.serviceStateEvent = _this.navDataService.serviceState.subscribe(({ action,name, data }:{ action:string,name:any,data:any }) => {
            if(!Object.is(name,'app-login-view')){
                return;
            }
            if (Object.is(action, 'viewrefresh')) {
                _this.$nextTick(()=>{
                    _this.parseViewParam(data);
                    if(_this.engine){
                        _this.engine.load();
                    }
                }); 
            }
        });
        if(_this.portletState){
            _this.portletStateEvent = _this.portletState.subscribe((res:any) =>{
                if(!Object.is(res.name,'AppLoginView')){
                    return;
                }
                if(Object.is(res.action,'refresh') && _this.refresh && _this.refresh instanceof Function){
                    _this.refresh();
                }
            })
        }
        _this.initViewCtx();
    }

    /**
     * 初始化视图操作参数
     *
     * @memberof AppLoginViewBase
     */  
    initViewCtx() {
        Object.assign(this.viewCtx, {
            app: this.$root,
            view: this,
            viewGlobal: {},
            viewNavData: {},
            viewNavContext: this.context,
            viewNavParam: this.viewparams,
            messagebox: AppMessageBox.getInstance(),
        });
        Object.assign(this.viewCtx, { appGlobal: this.$store.getters.getAppGlobal() });
        if (this.$store.getters.getRouteViewGlobal(this.context.srfsessionid)) {
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        } else {
            this.$store.commit('addRouteViewGlobal', { tag: this.context.srfsessionid, param: {} });
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            //  嵌入视图
            Object.assign(this.viewCtx, {
                topview: this.$store.getters.getView(this.context.srfsessionid)
            });
        } else {
            //  顶层视图
            this.$store.commit('addView', { tag: this.context.srfsessionid, param: this });
            Object.assign(this.viewCtx, { topview: this });
        }
    }

    /**
     * 销毁之前
     *
     * @memberof AppLoginViewBase
     */
    public beforeDestroy() {
        this.$store.commit('viewaction/removeView', this.viewtag);

        let _this: any = this
        if (_this.serviceStateEvent) {
            _this.serviceStateEvent.unsubscribe();
        }
        if (_this.portletStateEvent) {
            _this.portletStateEvent.unsubscribe();
        }
        if (_this.formDruipartEvent) {
            _this.formDruipartEvent.unsubscribe();
        }
        if (_this.engine) {
            _this.engine.destroy();
        }
    }

    /**
     * Vue声明周期(组件初始化完毕)
     *
     * @memberof AppLoginViewBase
     */
    public mounted() {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     * 
     * @memberof AppLoginViewBase
     */
    public afterMounted(){
        const _this: any = this;
        _this.engineInit();
            if (_this.loadModel && _this.loadModel instanceof Function) {
                _this.loadModel();
            }
    }




    /**
     * 关闭视图
     *
     * @param {any[]} args
     * @memberof AppLoginViewBase
     */
    public closeView(args: any[]): void {
        let _view: any = this;
        if (_view.viewdata) {
            _view.$emit('viewdataschange', Array.isArray(args)?args:[args]);
            _view.$emit('close', Array.isArray(args)?args:[args]);
        } else if (_view.$tabPageExp) {
            _view.$tabPageExp.onClose(_view.$route.fullPath);
        }else{
            _view.$router.back();
        }
    }

    /**
     * 应用名称
     *
     * @type {string}
     * @memberof AppLoginViewBase
     */
    public appTitle: string = Environment.AppTitle;

    /**
     * 登录数据对象
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public formData: any = {
        loginname: '',
        password: ''
    }

    /**
    * 登录提示
    *
    * @type {*}
    * @memberof AppLoginViewBase
    */
    public loginTip: any = "";

    /**
     * 值规则
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public rules = {
        loginname: [
            {required: true, message: this.$t('components.login.loginname.message'), trigger: 'change'},
        ],
        password: [
            {required: true, message: this.$t('components.login.password.message'), trigger: 'change'},
        ],
    };

    /**
     * 登陆处理
     *
     * @memberof AppLoginViewBase
     */
    public handleSubmit(): void {
        // 清除cookie
        let leftTime = new Date();
        leftTime.setTime(leftTime.getSeconds() - 1000);
        document.cookie = "ibzuaa-token=;expires=" + leftTime.toUTCString();
        const form: any = this.$refs.loginForm;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        if (!validatestate) {
            return;
        }
        const loginname: any = this.formData.loginname;
        const password: any = this.formData.password;
        const post: Promise<any> = this.$http.post('/v7/login', this.formData, true);
        post.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                if (data && data.token) {
                    localStorage.setItem('token', data.token);
                    Util.setCookie('ibzuaa-token',data.token,0);
                }
                if(data && data.user){
                    localStorage.setItem('user', JSON.stringify(data.user));
                }
                // 设置cookie,保存账号密码7天
                Util.setCookie("loginname",loginname, 7);
                // 跳转首页
                const url: any = this.$route.query.redirect ? this.$route.query.redirect : '*';
                this.$router.push({path: url});
            }
        }).catch((error: any) => {
            // 登录提示
            const data = error.data;
            if (data && data.message) {
                this.loginTip = data.message;
                this.$Message.error({
                    content: (this.$t('components.login.loginfailed') as string)+' ' + data.message,
                    duration: 5,
                    closable: true
                });
            } else {
                this.$Message.error({
                    content: (this.$t('components.login.loginfailed') as string),
                    duration: 5,
                    closable: true
                });
            }
        });
    }

    /**
     * 重置页面
     * 
     * @memberof AppLoginViewBase
     */
    public goReset(): void {
        this.formData = {loginname: 'ibzadmin', password: '123456'};
    }

    /**
     * qq授权登录
     * @param AppLoginViewBase
     */
    public tencentHandleClick() {
        this.$Message.warning((this.$t('components.login.warning1') as string))
    }

    /**
     * 微信授权登录
     * @param AppLoginViewBase
     */
    public wechatHandleClick() {
        this.$Message.warning((this.$t('components.login.warning2') as string))
    }

}
</script>

<style lang='scss'>
@import './app-login-view.scss';
</style>